#!/usr/bin/env ruby
#
# $Id: util2ch.rb,v 1.22 2003/02/11 15:43:31 Yuukis Exp $
#
#Post
# Postľ˥򹹿@vadjֲޤǤäƤ....Τ
#  Τޤޤι¤̵ʤʡľ
#
#Read
# cacheιե饰"+"ǥե륿󥰤Ǥ餤ʡȤ
#  ʤsubjectFrameUpdateʲ˱ʤ褦ʵ뤬.....(^^;
# ⸡
# C.i.ȤιưΤ@urlviewɽǤ饫å票ʡȤ
## ϲǽˤʤäԤϤޤ
##  gtkrc桼ˤMonafont Independentˤ롣
##  ʳǥɽboldȤɲáʡ
## ˥塼κͤ롣 (ɤäʡʤ)
## Comboư褦ˡ (datȤ꤬뤫餽θ夫)
#
## subject.txtΤgzipǼdat̾ (Ƕdatgzip֤ʤ ?)
## 2chɤǶ٤Ż뤷Ƥ뤿ᡣ

require 'nkf'
require 'net/http'
Net::HTTP.version_1_2
S = 'subject.txt'

class Util2ch
	def initialize
		@bbsHash = {}
		@bookmark = []
		@userAbone = []
	end

	def server(board)
		return(@bbsHash[board])
	end

	def parseUri(uri)
		server = ''
		board = ''
		uri.sub(/http:\/\/(.*)\/(.*)\/.*/) {
			server = $1
			board = $2
		}
		return([server, board])
	end

	def parseUri2(uri)
		server = ''
		board = ''
		uri.sub(/http:\/\/(.*?)(\/.*)/) {
			server = $1
			board = $2
		}
		return([server, board])
	end

	def infoRead(info)
		fh = open(info)
		last = fh.read
		last.sub!('Last-Modified: ', '')
		last.chomp!
		fh.close
		return(last)
	end

	def infoWrite(str, info)
		last = "Last-Modified: #{str}\n"
		fh = open(info, 'w')
		fh.write last
		fh.close
	end

	def httpGetHeaders(info, gzip = false)
		header = {}
		header['User-Agent']= MonazillaUA
		header['If-Modified-Since']= infoRead(info) if File.exist?(info)
		header['Accept-Encoding']= 'gzip' if gzip
		return(header)
	end

	def httpGetSubject(from, to, info)
		server, path = parseUri2(from)
		header = httpGetHeaders(info, true)

		Net::HTTP.start(server, 80) {|http|
			begin

			response , = http.get(path, header)
			case response.code
			when '304'  # Use Local Copy
				#puts response.code
				return([true, response.code])
			when '200'  # OK
				#puts response.code
				fh = open("#{to}.gz", 'w')
				fh.write response.body
					fh.close
				system "#{Zcat} #{to}.gz"
				infoWrite(response.header['Last-Modified'], info)
				return([true, response.code])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, response.code])
			end
			rescue Net::ProtoRetriableError => err
				puts 'C.i. System Info:'
				puts 'Rubyɸźե饤֥net/http.rbΥС󤬸Ť褦Ǥ'
				puts 'datcacheݻԶ礬ФޤΤǡǿǤؤ뤳Ȥ򤪴ᤷޤ'
			end
		}
	end

	def httpGetDat(from, to, info)
		unless File.exist?(to)
			File.unlink(to+'.last') if File.exist?(to+'.last')
			File.unlink(to+'.cache') if File.exist?(to+'.cache')
		end
		server, path = parseUri2(from)
		header = httpGetHeaders(info)
		if File.exist?(to)
			filesize = File.stat(to).size - 1
			header['Range']= "bytes=#{filesize}-"
		end
		cache = to+'.cache'

		Net::HTTP.start(server, 80) {|http|
			begin

			response , = http.get(path, header)
			case response.code
			when '304'  # Use Local Copy
				#puts response.code
				unless File.exist?(to+'.cache')
					tmp = ''
					n = 0
					open(to, 'r') {|line|
						tmp << dat2str(line.read, n)
						n += 1
					}
					fh = open(cache, 'w')
					fh.write tmp if tmp
						fh.close
				end
			when '206'  # Partical Content
				#puts response.code
				if response.body[0] == 10
					n = IO.readlines(to).size
					fh = open(to, 'a+')
					tmp  = response.body[1,response.body.size-1]
					fh.write tmp if tmp
						fh.close
					if File.exist?(cache)
						fh = open(cache, 'a+')
						tmp = dat2str(tmp, n)
						fh.write tmp if tmp
							fh.close
					else
						tmp = ''
						n = 0
						open(to, 'r') {|line|
							tmp << dat2str(line.read, n)
							n += 1
						}
						fh = open(cache, 'w')
						fh.write tmp if tmp
							fh.close
					end
					infoWrite(response.header['Last-Modified'], info)
				else
					# "A Bone" ?
					header.delete('Range')
					header.delete('If-Modified-Since')
					retry
				end
			when '200'  # OK
				#puts response.code
				fh = open(to, 'w')
				fh.write response.body
					fh.close
				fh = open(to+'.cache', 'w')
				tmp = dat2str(response.body, 0)
				fh.write tmp if tmp
					fh.close
				infoWrite(response.header['Last-Modified'], info)
			else
				#puts 'Can\'t get. Network Problem ?'
			end
			rescue Net::ProtoRetriableError => err
				puts 'C.i. System Info:'
				puts 'Rubyɸźե饤֥net/http.rbΥС󤬸Ť褦Ǥ'
				puts 'datcacheݻԶ礬ФޤΤǡǿǤؤ뤳Ȥ򤪴ᤷޤ'
			end
		}
	end

	def getProfile
		return('unix') unless File.exist?("#{Root}profile")
		var = {}
		profile = IO.readlines("#{Root}profile")
		profile.each {|line|
			a = line.split("=")
			key = a.shift
			value = a.to_s.chomp
			var[key]= value
		}
		return(var['board'])
	end

	def setProfile(board)
		str = ''
		# str << "server(board)=#{server}\n"
		str << "board=#{board}\n"
		open("#{Root}profile", 'w').write str
	end

	def getBBSMenu
		bbsmenu = "#{Root}bbsmenu.html"
		bbsmenuInfo = bbsmenu + '.info'
		server, path = parseUri2(BBSMenuURI)
		header = httpGetHeaders(bbsmenuInfo, false)

		Net::HTTP.start(server, 80) {|http|
			response , = http.get(path, header)

			case response.code
			when '304'  # Use Local Copy
				#puts response.code
				unless File.exist?(bbsmenuInfo)
					infoWrite(response.header['Last-Modified'], bbsmenuInfo)
				end
				return([true, response.code])
			when '200'  # OK
				#puts response.code
				fh = open(bbsmenu, 'w')
				fh.write response.body
					fh.close
				infoWrite(response.header['Last-Modified'], bbsmenuInfo)
				return([true, response.code])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, response.code])
			end
		}
		#`w3m -dump_source #{BBSMenuURI} > #{Root}bbsmenu.html`
	end

	def parseBBSMenu
		bbsNameHash = {}
		getBBSMenu unless File.exist?("#{Root}bbsmenu.html")
		file = NKF.nkf('-exS', IO.readlines("#{Root}bbsmenu.html").join)
		file.gsub!(/.*<BR><BR><B>/m, '<BR><BR><B>')
		file.gsub!(/Ʊ.*/m, "Ʊ</A>\n")
		file.gsub!(/<br>/i, '')
		file.gsub!(/<\/B>.*/, '')
		file.gsub!(/^\n/, '')
		#file.gsub!(/<A HREF=http:\/\/sports2\.2ch\.net\/entrance2\/>.*/,
		#	'<A HREF=http://sports2.2ch.net/entrance2/>饦󥸥饷å<A><br>')
		# # 饦󥸥饷åΤJIS X 0201ΤᡢѴ

		bbsmenu = []

		file.each {|line|
			if line =~ /^<B>/
				bbsmenu << [line.sub(/<B>/, '').chomp, 'C-']
			else
				line.sub!(/<a href=(.*)>(.*)<\/a>/i){ bbsmenu << [$2, $1] }
			end
		}
		bbsmenu.each {|balk, value|
			if value =~ /^http:\/\/(.*)\/(.*)\//
				@bbsHash[$2]= $1
			end
		}

		if $cfg['favoriteBoards'] != []
			favorites = []
			$cfg['favoriteBoards'].each {|x|
				uri = "http://#{@bbsHash[x]}/#{x}/"
				b = bbsmenu.flatten
				favorites << [b[b.index(uri) - 1], uri]
			}
			favorites.reverse_each {|a| bbsmenu.unshift(a) }
			bbsmenu.unshift(['Favorites', 'C-'])
		end
		return(bbsmenu)
	end

	def downloadSubjects(board)
		Dir.mkdir("#{Root}#{board}") unless File.exist?("#{Root}#{board}")
		writeOldSubjectsDummy(board) unless File.exist?("#{Root}#{board}/#{S}")
		File.rename("#{Root}#{board}/#{S}", "#{Root}#{board}/#{S}.tmp")

		result, code = httpGetSubject("http://#{server(board)}/#{board}/#{S}",
			"#{Root}#{board}/#{S}", "#{Root}#{board}/#{S}.last")

		# exit unless result  # 㳰ȯrescue٤

		case code
		when '304'
			File.rename("#{Root}#{board}/#{S}.tmp", "#{Root}#{board}/#{S}")
			return('Not Modified')
		when '200'
			File.rename("#{Root}#{board}/#{S}.tmp", "#{Root}#{board}/#{S}.old")
			fh = open("#{Root}#{board}/#{S}", 'r')
			str = NKF.nkf('-exS', fh.read)
			fh.close
			fh = open("#{Root}#{board}/#{S}", 'w')
			fh.write str
			fh.close
			if File.stat("#{Root}#{board}/#{S}.old").size < 100
				fh = open("#{Root}#{board}/#{S}.old", 'w')
				fh.write str
				fh.close
			end
			return('Update Done')
		end
	end

	def writeOldSubjectsDummy(board)
		str = "0000000000.dat<>util2ch (0)\n"
		fh = open("#{Root}#{board}/#{S}", 'w')
		fh.write str
		fh.close
	end

	def parseSubjects(board, fn, word = nil, bookmark = false)
		subjects = []
		lines = IO.readlines("#{Root}#{board}/#{fn}")
		lines.each {|thread|
			thread.sub!(/(.*)<>(.*)\((.*)\)/) {
				if word
					d = $1 ; f = $3 ; s = dat2txt($2)
					subjects << [d, f, s] if s =~ /#{word}/ie
				elsif bookmark
					d = $1 ; f = $3 ; s = dat2txt($2)
					subjects << [d, f, s] if bookmark?(d)
				else
					d = $1 ; f = $3 ; s = dat2txt($2)
					subjects << [d, f, s] unless abone?(d)
				end
			}
		}
		return(subjects)
	end

	def getSubjects(board, get = false, word = false, statusfilter = false, bookmark = false)
		get = true unless File.exist?("#{Root}#{board}/#{S}")
		if get
			downloadSubjects(board)
		else
			return(parsedSubjectGet(board, word, statusfilter, bookmark)) if File.exist?("#{Root}#{board}/#{S}.cache") 
		end

		results = []
		Dir.mkdir("#{Root}#{board}/cache/") unless File.exist?("#{Root}#{board}/cache/")
		caches = Dir.entries("#{Root}#{board}/cache/")
		newSubjects = parseSubjects(board, "#{S}", word, bookmark)
		writeOldSubjectsDummy(board) unless File.exist?("#{Root}#{board}/#{S}.cache")
		oldSubjects = parseSubjects(board, "#{S}.old", word, bookmark)
		newSubjects.each {|th|
			old = []
			oldSubjects.each {|oth|
				old = oth if th[0] == oth[0]
			}
			if caches.index(th[0])
				th.unshift("C")
			else
				th.unshift(" ")
			end
			if old == []
				unless statusfilter
					th[0, 0]= "N"
					cached = cachedThread(board, th[2])
					th[4, 0]= cached
					th[2, 0]= cacheCompare(th[3], cached)
					results << th
				end
			elsif th[2].to_i > old[1].to_i
				th[0, 0]= "U"
				cached = cachedThread(board, th[2])
				th[4, 0]= cached
				th[2, 0]= cacheCompare(th[3], cached)
				results << th
			else
				unless statusfilter
					th[0, 0]= " "
					cached = cachedThread(board, th[2])
					th[4, 0]= cached
					th[2, 0]= cacheCompare(th[3], cached)
					results << th
				end
			end
		}
		parsedSubjectSave(board, results)
		return(results)
	end

	def findSubjects(board, word)
		results = []
		caches = Dir.entries("#{Root}#{board}/cache/")
		newSubjects = parseSubjects(board, "#{S}", word)
		oldSubjects = parseSubjects(board, "#{S}.old", word)
		newSubjects.each {|th|
			old = []
			oldSubjects.each {|oth|
				old = oth if th[0] == oth[0]
			}
			if caches.index(th[0])
				th.unshift("C")
			else
				th.unshift(" ")
			end
			if old == []
				results << th.unshift("N")
			elsif th[2].to_i > old[2].to_i
				results << th.unshift("U")
			else
				results << th.unshift("")
			end
		}
		return(results)
	end

	def cachedThread(board, dat)
		return('') unless File.exist?("#{Root}#{board}/cache/#{dat}")
		return(IO.readlines("#{Root}#{board}/cache/#{dat}").size.to_s)
	end

	def cacheCompare(dat, cache)
		return('') if cache == ''
		return('=') if dat.to_i == cache.to_i
		return('+') if dat.to_i > cache.to_i
		return('?')
	end

	def parsedSubjectGet(board, word = false, statusfilter = false, bookmark = false)
		subjects = []
		array = IO.readlines("#{Root}#{board}/#{S}.cache")
		array.each {|line|
			th = line.split('<>')
			th[6].gsub!("&lt;&gt;", "<>")
			if word
				subjects << th if th[6] =~ /#{word}/ie
			elsif statusfilter
				subjects << th if th[0] == 'U'
			elsif bookmark
				subjects << th if bookmark?(th[3])
			else
				subjects << th unless abone?(th[3])
			end
		}
		return(subjects)
	end

	def parsedSubjectSave(board, array)
		str = ''
		array.each {|th|
			th[6].gsub!("<>", "&lt;&gt;")
			str << th.join("<>") + "\n"
		}
		fh = open("#{Root}#{board}/#{S}.cache", 'w')
		fh.write str
		fh.close
	end

	def bookmark?(dat)
		return(@bookmark.include?(dat))
	end

	def getBookmark(board)
		if File.exist?("#{Root}#{board}/bookmark.dat")
			a = IO.readlines("#{Root}#{board}/bookmark.dat")
			a.each {|th| @bookmark << th.chomp }
		else
			@bookmark = []
		end
	end

	def addBookmark(dat)
		@bookmark << dat.chomp
	end

	def deleteBookmark(dat)
		@bookmark.delete(dat)
	end

	def writeBookmark(board)
		str = ''
		@bookmark.each {|line| str << line + "\n" }
		fh = open("#{Root}#{board}/bookmark.dat", 'w')
		fh.write str
		fh.close
		@bookmark = []
	end

	def downloadDat(board, dat)
		t = "http://#{@bbsHash[board]}/#{board}/dat/#{dat}"
		f = "#{Root}#{board}/cache/#{dat}"
		httpGetDat(t, f, "#{f}.last")
	end

	def dat2str(datstr, lastnum)
		str = ''
		lastnum += 1
		datstr.each {|line|
			NKF.nkf('-exS', line).gsub!(/(.*)<>(.*)<>(.*)<>\s*(.*)\s*<>/) {
				str << "#{lastnum}: #{dat2txt($1)} <#{$2}> : #{$3}\n\n#{spaceManege(dat2txt($4))}\n\n-----\n"
			}
			lastnum += 1
		}
		return(str)
	end

	def parseDat(board, dat)  # [title, body]֤Τα
		th = []
		open("#{Root}#{board}/cache/#{dat}") {|line|
			NKF.nkf('-exS', line.read).gsub!(/(.*)<>(.*)<>(.*)<>(.*)<>/) {
				th << { 'name' => dat2txt($1),
						'mail' => $2,
						'date' => $3,
						'body' => spaceManege(dat2txt($4)) }
				}
		}
		return(th)
	end

	def parseThreadHash(array)
		str = ''
		n = 1
		array.each {|h|
			str << "#{n}: #{h['name']} <#{h['mail']}> : #{h['date']}\n\n"
			str << "#{spaceManege(h['body'])}\n\n-----\n"
			n += 1
		}
		return(str)
	end

	def dat2txt(str)
		convertStrings = {  /\s*<br>\s*/ => "\n", 
							'&gt;' => '>',
							'&lt;' => '<',
							'&nbsp;' => ' ',
							# '&nbsp' => ' ',
							'&thinsp;' => ' ',
							'&amp;' => '&', 
							'&quot;' => '"' }
		convertStrings.each {|from, to|
			str.gsub!(from, to)
		}
		return(linkdelete(str))
	end

	def spaceManege(str)
		results = ''
		str.each {|line|
			#line.gsub!(/^\s*/, '')
			results << ' ' + line
		}
		return(results)
	end

	def linkdelete(str)
		str.gsub!(/<a href=.*?>/, '')
		str.gsub!('</a>', '')
		return(str)
	end

	def getThread(board, dat)
		downloadDat(board, dat)
		fh = open("#{Root}#{board}/cache/#{dat}.cache", 'r')
		str = fh.read
		fh.close
		return(str)
	end

	def getFollowUp(board, dat, num)
		a = IO.readlines("#{Root}#{board}/cache/#{dat}")
		return('No Match.') if num-1 > a.size
		return(dat2str(a[num-1], num-1))
	end

	def parsedDatSave(board, dat, str)
		fh = open("#{Root}#{board}/cache/#{dat}.cache", 'w')
		fh.write str
		fh.close
	end

	def cachedThreadSave(board, dat)
		str = ''
		oCache = open("#{Root}#{board}/#{S}.cache")
		oldCache = oCache.read
		oCache.close

		oldCache.each {|th|
			if th =~ /#{dat}/
				a = th.split('<>')
				a[1]= 'C'
				a[2]= '='
				a[5]= a[4]
				th = a.join('<>')
			end
			str << th
		}

		nCache = open("#{Root}#{board}/#{S}.cache", 'w')
		nCache.write str
		nCache.close
	end

	def abone?(dat)
		if @userAbone.assoc(dat)
			return(true)
		else
			return(false)
		end
	end

	def getUserAbone(board)
		if File.exist?("#{Root}#{board}/abone.dat")
			a = IO.readlines("#{Root}#{board}/abone.dat")
			a.each {|th|
				x = th.chomp.split('<>')
				x[1].gsub!("&lt;&gt;", "<>")
				@userAbone << x
			}
		else
			@userAbone = []
		end
	end	

	def addUserAbone(dat, title)
		@userAbone << [dat, title.gsub('<>', '&lt;&gt;')]
	end	

	def writeUserAbone(board)
		str = ''
		@userAbone.each {|a| str << a.join('<>') + "\n" }
		fh = open("#{Root}#{board}/abone.dat", 'w')
		fh.write str
		fh.close
		@userAbone = []
	end

	def netUp
		server = 'wids.net'
		path = '/lab/CiRelease.dat'
		header = {}
		header['User-Agent']= MonazillaUA
		Net::HTTP.start(server, 80) {|http|
			response , = http.get(path, header)

			case response.code
			when '200'  # OK
				#puts response.code
				return([false, '']) if response.body =~ CiVersion
				return([true, response.body])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, ''])
			end
		}
	end
end

class CookieExcepton < StandardError ; end
class TimeExcepton < StandardError ; end

class PostMessage2ch  # code from goRua 0.15(Pre). thanks.
	def convert_and_encode(str)
		str=NKF::nkf('-sxE',str)
		return str.gsub(/[^a-zA-Z0-9_.-]/n){sprintf('%%%02X',$&.unpack('C')[0]) }
	end

	def postMessage(server, board, thread, name, mailto, message)
		thread = thread.gsub('.dat', '')
		kakikomu='񤭤'
		kakikomu = convert_and_encode(kakikomu)
		name = convert_and_encode(name)
		mailto = convert_and_encode(mailto)
		message = convert_and_encode(message)
		num_of_trial = 0 
		time = Time.now.to_i.to_s
   
		header = {}
		header['User-Agent']= MonazillaUA
		header['X-2ch-UA']= MonazillaUA
		header['Referer']= "http://#{server}/test/read.cgi/#{board}/#{thread}/"
		# header['Referer']= "http://#{server}/#{board}/index2.html"
		header['Content-Type']= 'application/x-www-form-urlencoded'
		header['Cookie']= "NAME=#{name};MAIL=#{mailto}"

		Net::HTTP.start(server, 80){ |http|
			begin
				response , = http.post( "/test/bbs.cgi",
				"submit=#{kakikomu}&FROM=#{name}&mail=#{mailto}&MESSAGE=#{message}&bbs=#{board}&key=#{thread}&time=#{time}",
				header)

				body = NKF::nkf('-exS',response.body)
				if response.code == '200'
				# navi2ch 1.5.1 
					if /񤭤ߤޤ/ =~ body
						return true, '񤭹(1)'
					elsif /ţңңϣҡ([^<]+)/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /ţңңϣҡ/ =~ body
						/<b>(.*?)<br>/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /åʤڤǤ/ =~ body || /\<!-- 2ch_X:cookie --\>/ =~ body
						num_of_trial += 1 
						if num_of_trial < 2
							header['Cookie'] += ';' + response['Set-Cookie']
							raise CookieExcepton
						end
						return false,'񤭤ߥ顼: åʤڤǤ'
					else
						STDERR.print body
						return false,'ν񤭤ߥ顼(1)'
					end
				else
					STDERR.print body
					return false,'ν񤭤ߥ顼(2)'
				end
			rescue Net::ProtoRetriableError
				return true, '쥯ȥڡ--餯񤭤--׳ǧ(2)'
			rescue TimeExcepton
				retry
			rescue CookieExcepton
				retry
			rescue
				# print "㳰ȯ񤭤ޤ줿ɤ狼ޤ\n"
				return false,'㳰ȯ񤭤ޤ줿ɤ狼ޤ'
			end
		}
	end

	def getAAList
		if File.exist?("#{Root}aa.list")
			fn = "#{Root}aa.list"
		else
			fn = "#{ScriptRoot}aa.list"
		end
		aalist = IO.readlines(fn)
		return(aalist)
	end

	def infoRead(info)
		return([$cfg['defaultName'], $cfg['defaultMailto']]) unless File.exist?(info)
		name = ''
		mail = ''
		fh = open(info)
		post = fh.read
		post.each {|line|
			case line
			when /^Name:(.*)/
				name = $1
			when /^Mail:(.*)/
				mail = $1
			end
		}
		fh.close
		name = '' if name.strip == ''
		mail = '' if mail.strip == ''
		return([name.sub(/^ /, ''), mail.sub(/^ /, '')])
	end

	def infoWrite(name, mail, info)
		post = "Name: #{name}\nMail: #{mail}\n"
		fh = open(info, 'w')
		fh.write post
		fh.close
	end

end

# Util2ch.new.getBookmark('unix')
